



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++学习笔记--从虚函数说开去</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++学习笔记--从虚函数说开去</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 15:20:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>虚函数与纯虚函数</strong>：</p>
<p>虚函数：在某基类中声明为virtual并在一个或多个派生类中被重新定义的成员函数，virtual &nbsp;函数返回类型 &nbsp;函数名（参数表）{函数体;} ，实现多态性，<strong>通过指向派生类的基类指针或引用</strong>，访问派生类中同名覆盖成员函数。注意虚函数在基类中是有定义的，即便定义是空。</p>
<p>纯虚函数：在基类中是没有定义的，必须由派生类重定义实现，否则不能由对象进行调用。</p>
<p>看下面的例子：</p>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;<br />
using namespace std;<br />
class Cshape<br />
{<br />
public:<br />
    void SetColor(int color){m_nColor=color;}<br />
    virtual void Display(void){};<br />
private:<br />
    int m_nColor;<br />
};

class Crectangle:public Cshape{ //公有继承<br />
public:

};

void main()<br />
{<br />
    Crectangle obRectangle;<br />
    Cshape* pShape=&amp;obRectangle;<br />
    pShape-&gt;Display();<br />
}</pre>
</div>
<p>上面例子中，Display是虚函数，虽然是空定义，并且在派生类中没有重写该函数，但是上面的代码在编译阶段不会出错，而是在链接时出错，而如果将Display声明为纯虚函数，即 virtual void Display( )=0; 则该代码将在编译阶段出错，即编译器需要确保纯虚函数必须在子类中进行重写。注意：<strong>如果在基类中定义了纯虚函数，那么基类是不能实例化对象的，它只是提供一个接口</strong>，就想老板造房子，我就告诉你干嘛，具体怎么干还得靠自己，但是完全不说，你也当然不知道要干嘛。</p>
<p><strong>虚函数怎么实现多态</strong>？</p>
<p>前面讲到虚函数的作用主要是实现多态，那么具体是怎么实现的？为什么需要用基类指针来指向派生类对象？</p>
<p><strong> 多态：C++中实现多态有虚函数，抽象类，重载，覆盖，模板等方法，虚函数是最重要的一种</strong>。把不同的子类对象当做父类来看，可以屏蔽不同子类对象之间的差异，写出通用的代码，做出通用的编程，以适应需求的不断变化，<strong>实际上是通过基类来访问子对象的</strong>。那么子对象在程序中是怎么通过基类来找到与该对象对应的方法呢？这就要说到<strong>虚函数表</strong>。</p>
<p><strong>虚函数表</strong></p>
<p>虚函数是通过虚函数表来实现的，在有虚函数的类的实例中这个表被分配在了这个实例的内存中，所以当用父类的指针来操作一个子类的时候，这张虚函数表就像一张地图，指明实际应该调用的函数。</p>
<p>这里引用一下CSDN上的一篇题为&ldquo;C++虚函数表解析&rdquo;博客（博主的地址是<a href="http://blog.csdn.net/haoel" rel="external nofollow noreferrer">http://blog.csdn.net/haoel</a>）：</p>
<p>假设我们有这样一个类，</p>
<div>
<pre class="prettyprint linenums">class Base{<br />
public:<br />
    virtual void f(){cout &lt;&lt; "Base::f" &lt;&lt; endl;}<br />
    virtual void g(){cout &lt;&lt; "Base::g" &lt;&lt; endl;}<br />
    virtual void h(){cout &lt;&lt; "Base::h" &lt;&lt; endl;}<br />
};</pre>
</div>
<p>我们可以通过Base的实例来得到虚函数表：下面是实际例程：</p>
<div>
<pre class="prettyprint linenums">void main()<br />
{<br />
   typedef void(*Fun)(void); //这里是定义一个参数为void，返回值为void的函数指针。<br />
   Base b;<br />
   Fun pFun=NULL;<br />
   cout &lt;&lt; "虚函数表地址：" &lt;&lt; (int*)(&amp;b) &lt;&lt; endl;<br />
   cout &lt;&lt; "虚函数表--第一个函数地址：" &lt;&lt; (int*)*(int*)(&amp;b) &lt;&lt; endl;<br />
   // 调用第一个虚拟函数<br />
   pFun=(Fun)*((int*)*(int*)(&amp;b));<br />
   pFun();<br />
}</pre>
</div>
<p>程序运行结果如下：(Windows 7 + Visual C++6.0)</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/612661/201405/311540206811070.png" /></p>
<p>由以上程序可以知道，如果要调用Base::g 和Base::h，代码如下：</p>
<div>
<pre class="prettyprint linenums">   pFun=(Fun)*((int*)*(int*)(&amp;b)+);<br />
   pFun=(Fun)*((int*)*(int*)(&amp;b)+);</pre>
</div>
<p>虚拟函数表的图示如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/612661/201405/311546560723477.png" /></p>
<p><strong>类中的虚函数所占内存为多少？</strong></p>
<p>虚函数要占用4个字节的内存空间，用来指定虚函数的虚拟函数表的入口地址。既然是入口地址，所以一个类的虚函数所占的地址是不变的，和虚拟函数的个数没有关系，如果派生类继承了多个超类的虚拟函数，那个这个派生类的虚拟函数所占用的内存空间等于4*（超类个数），即为每个超类维护一张虚函数表（关于多重继承的虚函数表内存分布，更详细请参考博客http://blog.csdn.net/haoel/article/details/1948051#）。<strong>另外要注意的是：父类和子类共享一个虚函数指针</strong>。这一点可以从下面的代码中看出：</p>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;<br />
using namespace std;<br />
class Base{<br />
public:<br />
    virtual void f(){cout &lt;&lt; "Base::f" &lt;&lt; endl;}<br />
    virtual void g(){cout &lt;&lt; "Base::g" &lt;&lt; endl;}<br />
    virtual void h(){cout &lt;&lt; "Base::h" &lt;&lt; endl;}<br />
};

class Child:public Base{<br />
    virtual void i(){cout &lt;&lt; "Child::i" &lt;&lt; endl;}<br />
};<br />
void main()<br />
{<br />
    typedef void(*Fun)(void);<br />
    Child child;<br />
    Base* pBase=&amp;child;<br />
    Fun pFun=NULL;<br />
    cout &lt;&lt; sizeof(Base) &lt;&lt; " " &lt;&lt; sizeof(Child) &lt;&lt; endl;<br />
    cout &lt;&lt; "虚拟函数i()的地址是：" &lt;&lt; (int*)*(int*)pBase+ &lt;&lt; endl;<br />
    pFun=(Fun)*((int*)*(int*)pBase+);<br />
    pFun();<br />
}</pre>
</div>
<p>代码运行结果如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/612661/201405/311612002136487.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rql1znk9.html">&lbrack;Think In Java&rsqb;基础拾遗4 - 并发</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mzze0q.html">IEnumerable  遍历用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmmkpe9.html">Android开发面试经&mdash;&mdash;2&period;常见Android基础笔试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xpoyg9.html">Jquery 对象与 DOM对象的相互转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm1jkk9.html">ionic 嵌套view  的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yp33eq.html">Android四大组件一----Activity</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmgr2l9.html">Android实例-读取设备联系人&lpar;XE8&plus;小米2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1w7pj8.html">MySQL join buffer使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm364x9.html">使用&amp;lt&semi;br&amp;gt&semi;标签分行显示文本</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okxg2l9.html">istringstream和ostringstream的使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k13ewj9.html">关于两次指针（struct型）传参数的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/950gklz8.html">&period;NET 微信开放平台接口（接收短信、发送短信）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zwle19.html">Log4j与Log4j2</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge0nyz8.html">centos7上安装0penStack</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp1zyvq.html">关于Mac OS 使用GIT的引导</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gj6w0q.html">2018-03-11 20165235 祁瑛 Java第二周考试总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7onp3x8.html">The Monocycle（bfs）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvxzwr8.html">Sprint 冲刺第三阶段第3-5天</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyd1rv9.html">JavaScript随机生成信用卡卡号的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve5e7z9.html">laravel扩展推荐</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwl36ok9.html">802&period;1p 优先级与内部优先级的映射关系</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvzplxq.html">&lbrack;COGS1000&rsqb;伊吹萃香 最短路</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pm52r8.html">lxm --- ans lb config</a>
			</li>
						<li><a href="https://www.batexi.com/a/9534re68.html">一些平台无关的整型类型&comma;int8&lowbar;t&comma;uint8&lowbar;t&period;&period;&period;&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kowkoq.html">LibreOJ &num;539&period; 「LibreOJ NOIP Round &num;1」旅游路线（倍增&plus;二分）</a>
			</li>
						<li><a href="https://www.batexi.com/a/95340mz8.html">hibernate实现数据实体复制保存</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1v0r42q.html">HashCode与Equals回顾</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1v0ry2q.html">powerdesigner中物理模型与sql脚本的以及与数据库的连接设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pewkn8.html">socketpair &plus; signal &plus; select 的套路</a>
			</li>
						<li><a href="https://www.batexi.com/a/963x3l49.html">python部分知识归纳</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
